"""
Automatically generated by gen-cli.py.
"""
from argparse import Namespace
from typing import Type

from wai.common.cli import CLIFactory, CLIInstantiable
from wai.common.meta.typing import VAR_ARGS_TYPE

from wai.common.cli.options._TypedOption import TypedOption
from builtins import str


class COCOReaderCLIFactory(CLIFactory):
    """
    Factory which instantiates the COCOReader class.
    """
    # Options
    input_files = TypedOption('-I', '--input-files', type=str, action='append', help='Files containing lists of input annotation files (can use glob syntax)')
    inputs = TypedOption('-i', '--inputs', type=str, action='append', help='Input annotations files (can use glob syntax)', metavar='files')
    negative_files = TypedOption('-N', '--negative-files', type=str, action='append', help='Files containing lists of negative images (can use glob syntax)')
    negatives = TypedOption('-n', '--negatives', type=str, action='append', help='Image files that have no annotations (can use glob syntax)', metavar='image')

    @classmethod
    def production_class(self, namespace: Namespace) -> Type[CLIInstantiable]:
        from wai.annotations.coco.io._COCOReader import COCOReader
        return COCOReader

    @classmethod
    def init_args(self, namespace: Namespace) -> VAR_ARGS_TYPE:
        return (namespace,), dict()
